com.amazonaws.services.elastictranscoder

## Class AmazonElasticTranscoderClient

- java.lang.Object
- - com.amazonaws.AmazonWebServiceClient
  - - com.amazonaws.services.elastictranscoder.AmazonElasticTranscoderClient

All Implemented Interfaces:
  AmazonElasticTranscoder

Direct Known Subclasses:
  AmazonElasticTranscoderAsyncClient

    @ThreadSafe
    public class AmazonElasticTranscoderClient
    extends AmazonWebServiceClient
    implements AmazonElasticTranscoder

Client for accessing Amazon Elastic Transcoder. All service calls made using this client are blocking, and will not return until the service call completes.

<fullname>AWS Elastic Transcoder Service</fullname>

The AWS Elastic Transcoder Service.

### Field Summary

Fields
`protected static ClientConfigurationFactory` `configFactory` Client configuration factory providing ClientConfigurations tailored to this client

### Fields inherited from class com.amazonaws.AmazonWebServiceClient

`client, clientConfiguration, endpoint, LOGGING_AWS_REQUEST_METRIC, requestHandler2s, timeOffset`

### Fields inherited from interface com.amazonaws.services.elastictranscoder.AmazonElasticTranscoder

`ENDPOINT_PREFIX`

### Constructor Summary

Constructors
Constructor and Description
`AmazonElasticTranscoderClient()` Constructs a new client to invoke service methods on Amazon Elastic Transcoder.
`AmazonElasticTranscoderClient(AWSCredentials awsCredentials)` Constructs a new client to invoke service methods on Amazon Elastic Transcoder using the specified AWS account credentials.
`AmazonElasticTranscoderClient(AWSCredentials awsCredentials, ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on Amazon Elastic Transcoder using the specified AWS account credentials and client configuration options.
`AmazonElasticTranscoderClient(AWSCredentialsProvider awsCredentialsProvider)` Constructs a new client to invoke service methods on Amazon Elastic Transcoder using the specified AWS account credentials provider.
`AmazonElasticTranscoderClient(AWSCredentialsProvider awsCredentialsProvider, ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on Amazon Elastic Transcoder using the specified AWS account credentials provider and client configuration options.
`AmazonElasticTranscoderClient(AWSCredentialsProvider awsCredentialsProvider, ClientConfiguration clientConfiguration, RequestMetricCollector requestMetricCollector)` Constructs a new client to invoke service methods on Amazon Elastic Transcoder using the specified AWS account credentials provider, client configuration options, and request metric collector.
`AmazonElasticTranscoderClient(ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on Amazon Elastic Transcoder.

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`CancelJobResult` `cancelJob(CancelJobRequest cancelJobRequest)` The CancelJob operation cancels an unfinished job.
`CreateJobResult` `createJob(CreateJobRequest createJobRequest)` When you create a job, Elastic Transcoder returns JSON data that includes the values that you specified plus information about the job that is created.
`CreatePipelineResult` `createPipeline(CreatePipelineRequest createPipelineRequest)` The CreatePipeline operation creates a pipeline with settings that you specify.
`CreatePresetResult` `createPreset(CreatePresetRequest createPresetRequest)` The CreatePreset operation creates a preset with settings that you specify.
`DeletePipelineResult` `deletePipeline(DeletePipelineRequest deletePipelineRequest)` The DeletePipeline operation removes a pipeline.
`DeletePresetResult` `deletePreset(DeletePresetRequest deletePresetRequest)` The DeletePreset operation removes a preset that you've added in an AWS region.
`ResponseMetadata` `getCachedResponseMetadata(AmazonWebServiceRequest request)` Returns additional metadata for a previously executed successful, request, typically used for debugging issues where a service isn't acting as expected.
`ListJobsByPipelineResult` `listJobsByPipeline(ListJobsByPipelineRequest listJobsByPipelineRequest)` The ListJobsByPipeline operation gets a list of the jobs currently in a pipeline.
`ListJobsByStatusResult` `listJobsByStatus(ListJobsByStatusRequest listJobsByStatusRequest)` The ListJobsByStatus operation gets a list of jobs that have a specified status.
`ListPipelinesResult` `listPipelines()` Simplified method form for invoking the ListPipelines operation.
`ListPipelinesResult` `listPipelines(ListPipelinesRequest listPipelinesRequest)` The ListPipelines operation gets a list of the pipelines associated with the current AWS account.
`ListPresetsResult` `listPresets()` Simplified method form for invoking the ListPresets operation.
`ListPresetsResult` `listPresets(ListPresetsRequest listPresetsRequest)` The ListPresets operation gets a list of the default presets included with Elastic Transcoder and the presets that you've added in an AWS region.
`ReadJobResult` `readJob(ReadJobRequest readJobRequest)` The ReadJob operation returns detailed information about a job.
`ReadPipelineResult` `readPipeline(ReadPipelineRequest readPipelineRequest)` The ReadPipeline operation gets detailed information about a pipeline.
`ReadPresetResult` `readPreset(ReadPresetRequest readPresetRequest)` The ReadPreset operation gets detailed information about a preset.
`TestRoleResult` `testRole(TestRoleRequest testRoleRequest)` Deprecated.
`UpdatePipelineResult` `updatePipeline(UpdatePipelineRequest updatePipelineRequest)` Use the `UpdatePipeline` operation to update settings for a pipeline.
`UpdatePipelineNotificationsResult` `updatePipelineNotifications(UpdatePipelineNotificationsRequest updatePipelineNotificationsRequest)` With the UpdatePipelineNotifications operation, you can update Amazon Simple Notification Service (Amazon SNS) notifications for a pipeline.
`UpdatePipelineStatusResult` `updatePipelineStatus(UpdatePipelineStatusRequest updatePipelineStatusRequest)` The UpdatePipelineStatus operation pauses or reactivates a pipeline, so that the pipeline stops or restarts the processing of jobs.
`AmazonElasticTranscoderWaiters` `waiters()`

### Methods inherited from class com.amazonaws.AmazonWebServiceClient

`addRequestHandler, addRequestHandler, beforeMarshalling, calculateCRC32FromCompressedData, checkMutability, configureRegion, createExecutionContext, createExecutionContext, createExecutionContext, createSignerProvider, endClientExecution, endClientExecution, getEndpointPrefix, getRequestMetricsCollector, getServiceAbbreviation, getServiceName, getServiceNameIntern, getSigner, getSignerByURI, getSignerProvider, getSignerRegionOverride, getTimeOffset, isProfilingEnabled, isRequestMetricsEnabled, makeImmutable, removeRequestHandler, removeRequestHandler, requestMetricCollector, setEndpoint, setEndpointPrefix, setRegion, setServiceNameIntern, setSignerRegionOverride, setTimeOffset, shutdown, useStrictHostNameVerification, withEndpoint, withRegion, withRegion, withTimeOffset`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface com.amazonaws.services.elastictranscoder.AmazonElasticTranscoder

`setEndpoint, setRegion, shutdown`

### Field Detail

#### configFactory

    protected static final ClientConfigurationFactory configFactory

Client configuration factory providing ClientConfigurations tailored to this client

### Constructor Detail

#### AmazonElasticTranscoderClient

    public AmazonElasticTranscoderClient()

Constructs a new client to invoke service methods on Amazon Elastic Transcoder. A credentials provider chain will be used that searches for credentials in this order:

- Environment Variables - AWS_ACCESS_KEY_ID and AWS_SECRET_KEY
- Java System Properties - aws.accessKeyId and aws.secretKey
- Instance profile credentials delivered through the Amazon EC2 metadata service

All service calls made using this new client object are blocking, and will not return until the service call completes.

See Also:
  `DefaultAWSCredentialsProviderChain`

#### AmazonElasticTranscoderClient

    public AmazonElasticTranscoderClient(ClientConfiguration clientConfiguration)

Constructs a new client to invoke service methods on Amazon Elastic Transcoder. A credentials provider chain will be used that searches for credentials in this order:

- Environment Variables - AWS_ACCESS_KEY_ID and AWS_SECRET_KEY
- Java System Properties - aws.accessKeyId and aws.secretKey
- Instance profile credentials delivered through the Amazon EC2 metadata service

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `clientConfiguration` - The client configuration options controlling how this client connects to Amazon Elastic Transcoder (ex: proxy settings, retry counts, etc.).
See Also:
  `DefaultAWSCredentialsProviderChain`

#### AmazonElasticTranscoderClient

    public AmazonElasticTranscoderClient(AWSCredentials awsCredentials)

Constructs a new client to invoke service methods on Amazon Elastic Transcoder using the specified AWS account credentials.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.

#### AmazonElasticTranscoderClient

    public AmazonElasticTranscoderClient(AWSCredentials awsCredentials,
                                         ClientConfiguration clientConfiguration)

Constructs a new client to invoke service methods on Amazon Elastic Transcoder using the specified AWS account credentials and client configuration options.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.
  `clientConfiguration` - The client configuration options controlling how this client connects to Amazon Elastic Transcoder (ex: proxy settings, retry counts, etc.).

#### AmazonElasticTranscoderClient

    public AmazonElasticTranscoderClient(AWSCredentialsProvider awsCredentialsProvider)

Constructs a new client to invoke service methods on Amazon Elastic Transcoder using the specified AWS account credentials provider.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentialsProvider` - The AWS credentials provider which will provide credentials to authenticate requests with AWS services.

#### AmazonElasticTranscoderClient

    public AmazonElasticTranscoderClient(AWSCredentialsProvider awsCredentialsProvider,
                                         ClientConfiguration clientConfiguration)

Constructs a new client to invoke service methods on Amazon Elastic Transcoder using the specified AWS account credentials provider and client configuration options.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentialsProvider` - The AWS credentials provider which will provide credentials to authenticate requests with AWS services.
  `clientConfiguration` - The client configuration options controlling how this client connects to Amazon Elastic Transcoder (ex: proxy settings, retry counts, etc.).

#### AmazonElasticTranscoderClient

    public AmazonElasticTranscoderClient(AWSCredentialsProvider awsCredentialsProvider,
                                         ClientConfiguration clientConfiguration,
                                         RequestMetricCollector requestMetricCollector)

Constructs a new client to invoke service methods on Amazon Elastic Transcoder using the specified AWS account credentials provider, client configuration options, and request metric collector.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentialsProvider` - The AWS credentials provider which will provide credentials to authenticate requests with AWS services.
  `clientConfiguration` - The client configuration options controlling how this client connects to Amazon Elastic Transcoder (ex: proxy settings, retry counts, etc.).
  `requestMetricCollector` - optional request metric collector

### Method Detail

#### cancelJob

    public CancelJobResult cancelJob(CancelJobRequest cancelJobRequest)

The CancelJob operation cancels an unfinished job.

<note>

You can only cancel a job that has a status of `Submitted`. To prevent a pipeline from starting to process a job while you're getting the job identifier, use UpdatePipelineStatus to temporarily pause the pipeline.

</note>

Specified by:
  `cancelJob` in interface `AmazonElasticTranscoder`
Parameters:
  `cancelJobRequest` - The `CancelJobRequest` structure.
Returns:
  Result of the CancelJob operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `ResourceInUseException` - The resource you are attempting to change is in use. For example, you are attempting to delete a pipeline that is currently in use.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### createJob

    public CreateJobResult createJob(CreateJobRequest createJobRequest)

When you create a job, Elastic Transcoder returns JSON data that includes the values that you specified plus information about the job that is created.

If you have specified more than one output for your jobs (for example, one output for the Kindle Fire and another output for the Apple iPhone 4s), you currently must use the Elastic Transcoder API to list the jobs (as opposed to the AWS Console).

Specified by:
  `createJob` in interface `AmazonElasticTranscoder`
Parameters:
  `createJobRequest` - The `CreateJobRequest` structure.
Returns:
  Result of the CreateJob operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `LimitExceededException` - Too many operations for a given AWS account. For example, the number of pipelines exceeds the maximum allowed.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### createPipeline

    public CreatePipelineResult createPipeline(CreatePipelineRequest createPipelineRequest)

The CreatePipeline operation creates a pipeline with settings that you specify.

Specified by:
  `createPipeline` in interface `AmazonElasticTranscoder`
Parameters:
  `createPipelineRequest` - The `CreatePipelineRequest` structure.
Returns:
  Result of the CreatePipeline operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `LimitExceededException` - Too many operations for a given AWS account. For example, the number of pipelines exceeds the maximum allowed.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### createPreset

    public CreatePresetResult createPreset(CreatePresetRequest createPresetRequest)

The CreatePreset operation creates a preset with settings that you specify.

<important>

Elastic Transcoder checks the CreatePreset settings to ensure that they meet Elastic Transcoder requirements and to determine whether they comply with H.264 standards. If your settings are not valid for Elastic Transcoder, Elastic Transcoder returns an HTTP 400 response (`ValidationException`) and does not create the preset. If the settings are valid for Elastic Transcoder but aren't strictly compliant with the H.264 standard, Elastic Transcoder creates the preset and returns a warning message in the response. This helps you determine whether your settings comply with the H.264 standard while giving you greater flexibility with respect to the video that Elastic Transcoder produces.

</important>

Elastic Transcoder uses the H.264 video-compression format. For more information, see the International Telecommunication Union publication Recommendation ITU-T H.264: Advanced video coding for generic audiovisual services.

Specified by:
  `createPreset` in interface `AmazonElasticTranscoder`
Parameters:
  `createPresetRequest` - The `CreatePresetRequest` structure.
Returns:
  Result of the CreatePreset operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `LimitExceededException` - Too many operations for a given AWS account. For example, the number of pipelines exceeds the maximum allowed.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### deletePipeline

    public DeletePipelineResult deletePipeline(DeletePipelineRequest deletePipelineRequest)

The DeletePipeline operation removes a pipeline.

You can only delete a pipeline that has never been used or that is not currently in use (doesn't contain any active jobs). If the pipeline is currently in use, `DeletePipeline` returns an error.

Specified by:
  `deletePipeline` in interface `AmazonElasticTranscoder`
Parameters:
  `deletePipelineRequest` - The `DeletePipelineRequest` structure.
Returns:
  Result of the DeletePipeline operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `ResourceInUseException` - The resource you are attempting to change is in use. For example, you are attempting to delete a pipeline that is currently in use.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### deletePreset

    public DeletePresetResult deletePreset(DeletePresetRequest deletePresetRequest)

The DeletePreset operation removes a preset that you've added in an AWS region.

<note>

You can't delete the default presets that are included with Elastic Transcoder.

</note>

Specified by:
  `deletePreset` in interface `AmazonElasticTranscoder`
Parameters:
  `deletePresetRequest` - The `DeletePresetRequest` structure.
Returns:
  Result of the DeletePreset operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### listJobsByPipeline

    public ListJobsByPipelineResult listJobsByPipeline(ListJobsByPipelineRequest listJobsByPipelineRequest)

The ListJobsByPipeline operation gets a list of the jobs currently in a pipeline.

Elastic Transcoder returns all of the jobs currently in the specified pipeline. The response body contains one element for each job that satisfies the search criteria.

Specified by:
  `listJobsByPipeline` in interface `AmazonElasticTranscoder`
Parameters:
  `listJobsByPipelineRequest` - The `ListJobsByPipelineRequest` structure.
Returns:
  Result of the ListJobsByPipeline operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### listJobsByStatus

    public ListJobsByStatusResult listJobsByStatus(ListJobsByStatusRequest listJobsByStatusRequest)

The ListJobsByStatus operation gets a list of jobs that have a specified status. The response body contains one element for each job that satisfies the search criteria.

Specified by:
  `listJobsByStatus` in interface `AmazonElasticTranscoder`
Parameters:
  `listJobsByStatusRequest` - The `ListJobsByStatusRequest` structure.
Returns:
  Result of the ListJobsByStatus operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### listPipelines

    public ListPipelinesResult listPipelines(ListPipelinesRequest listPipelinesRequest)

The ListPipelines operation gets a list of the pipelines associated with the current AWS account.

Specified by:
  `listPipelines` in interface `AmazonElasticTranscoder`
Parameters:
  `listPipelinesRequest` - The `ListPipelineRequest` structure.
Returns:
  Result of the ListPipelines operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### listPipelines

    public ListPipelinesResult listPipelines()

Description copied from interface: `AmazonElasticTranscoder`
Simplified method form for invoking the ListPipelines operation.

Specified by:
  `listPipelines` in interface `AmazonElasticTranscoder`
See Also:
  `AmazonElasticTranscoder.listPipelines(ListPipelinesRequest)`

#### listPresets

    public ListPresetsResult listPresets(ListPresetsRequest listPresetsRequest)

The ListPresets operation gets a list of the default presets included with Elastic Transcoder and the presets that you've added in an AWS region.

Specified by:
  `listPresets` in interface `AmazonElasticTranscoder`
Parameters:
  `listPresetsRequest` - The `ListPresetsRequest` structure.
Returns:
  Result of the ListPresets operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### listPresets

    public ListPresetsResult listPresets()

Description copied from interface: `AmazonElasticTranscoder`
Simplified method form for invoking the ListPresets operation.

Specified by:
  `listPresets` in interface `AmazonElasticTranscoder`
See Also:
  `AmazonElasticTranscoder.listPresets(ListPresetsRequest)`

#### readJob

    public ReadJobResult readJob(ReadJobRequest readJobRequest)

The ReadJob operation returns detailed information about a job.

Specified by:
  `readJob` in interface `AmazonElasticTranscoder`
Parameters:
  `readJobRequest` - The `ReadJobRequest` structure.
Returns:
  Result of the ReadJob operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### readPipeline

    public ReadPipelineResult readPipeline(ReadPipelineRequest readPipelineRequest)

The ReadPipeline operation gets detailed information about a pipeline.

Specified by:
  `readPipeline` in interface `AmazonElasticTranscoder`
Parameters:
  `readPipelineRequest` - The `ReadPipelineRequest` structure.
Returns:
  Result of the ReadPipeline operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### readPreset

    public ReadPresetResult readPreset(ReadPresetRequest readPresetRequest)

The ReadPreset operation gets detailed information about a preset.

Specified by:
  `readPreset` in interface `AmazonElasticTranscoder`
Parameters:
  `readPresetRequest` - The `ReadPresetRequest` structure.
Returns:
  Result of the ReadPreset operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### testRole

    @Deprecated
    public TestRoleResult testRole(TestRoleRequest testRoleRequest)

Deprecated.

The TestRole operation tests the IAM role used to create the pipeline.

The `TestRole` action lets you determine whether the IAM role you are using has sufficient permissions to let Elastic Transcoder perform tasks associated with the transcoding process. The action attempts to assume the specified IAM role, checks read access to the input and output buckets, and tries to send a test notification to Amazon SNS topics that you specify.

Specified by:
  `testRole` in interface `AmazonElasticTranscoder`
Parameters:
  `testRoleRequest` - The `TestRoleRequest` structure.
Returns:
  Result of the TestRole operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### updatePipeline

    public UpdatePipelineResult updatePipeline(UpdatePipelineRequest updatePipelineRequest)

Use the `UpdatePipeline` operation to update settings for a pipeline.

<important>

When you change pipeline settings, your changes take effect immediately. Jobs that you have already submitted and that Elastic Transcoder has not started to process are affected in addition to jobs that you submit after you change settings.

</important>

Specified by:
  `updatePipeline` in interface `AmazonElasticTranscoder`
Parameters:
  `updatePipelineRequest` - The `UpdatePipelineRequest` structure.
Returns:
  Result of the UpdatePipeline operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `ResourceInUseException` - The resource you are attempting to change is in use. For example, you are attempting to delete a pipeline that is currently in use.
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### updatePipelineNotifications

    public UpdatePipelineNotificationsResult updatePipelineNotifications(UpdatePipelineNotificationsRequest updatePipelineNotificationsRequest)

With the UpdatePipelineNotifications operation, you can update Amazon Simple Notification Service (Amazon SNS) notifications for a pipeline.

When you update notifications for a pipeline, Elastic Transcoder returns the values that you specified in the request.

Specified by:
  `updatePipelineNotifications` in interface `AmazonElasticTranscoder`
Parameters:
  `updatePipelineNotificationsRequest` - The `UpdatePipelineNotificationsRequest` structure.
Returns:
  Result of the UpdatePipelineNotifications operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `ResourceInUseException` - The resource you are attempting to change is in use. For example, you are attempting to delete a pipeline that is currently in use.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### updatePipelineStatus

    public UpdatePipelineStatusResult updatePipelineStatus(UpdatePipelineStatusRequest updatePipelineStatusRequest)

The UpdatePipelineStatus operation pauses or reactivates a pipeline, so that the pipeline stops or restarts the processing of jobs.

Changing the pipeline status is useful if you want to cancel one or more jobs. You can't cancel jobs after Elastic Transcoder has started processing them; if you pause the pipeline to which you submitted the jobs, you have more time to get the job IDs for the jobs that you want to cancel, and to send a CancelJob request.

Specified by:
  `updatePipelineStatus` in interface `AmazonElasticTranscoder`
Parameters:
  `updatePipelineStatusRequest` - The `UpdatePipelineStatusRequest` structure.
Returns:
  Result of the UpdatePipelineStatus operation returned by the service.
Throws:
  `ValidationException` - One or more required parameter values were not provided in the request.
  `IncompatibleVersionException`
  `ResourceNotFoundException` - The requested resource does not exist or is not available. For example, the pipeline to which you're trying to add a job doesn't exist or is still being created.
  `ResourceInUseException` - The resource you are attempting to change is in use. For example, you are attempting to delete a pipeline that is currently in use.
  `AccessDeniedException` - General authentication failure. The request was not signed correctly.
  `InternalServiceException` - Elastic Transcoder encountered an unexpected exception while trying to fulfill the request.

#### getCachedResponseMetadata

    public ResponseMetadata getCachedResponseMetadata(AmazonWebServiceRequest request)

Returns additional metadata for a previously executed successful, request, typically used for debugging issues where a service isn't acting as expected. This data isn't considered part of the result data returned by an operation, so it's available through this separate, diagnostic interface.

Response metadata is only cached for a limited period of time, so if you need to access this extra diagnostic information for an executed request, you should use this method to retrieve it as soon as possible after executing the request.

Specified by:
  `getCachedResponseMetadata` in interface `AmazonElasticTranscoder`
Parameters:
  `request` - The originally executed request
Returns:
  The response metadata for the specified request, or null if none is available.

#### waiters

    public AmazonElasticTranscoderWaiters waiters()

Specified by:
  `waiters` in interface `AmazonElasticTranscoder`